﻿#include "usb.h"
#include "hs_108fj.h"
#include "ui_hs_108fj.h"
#include "password.h"
#include <QString>
#include <QAbstractItemView>
#include <QByteArray>
#include <QDebug>

HS_108fj::HS_108fj(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::HS_108fj)
{
    ui->setupUi(this);
    //this->setStyleSheet("background-color: qlineargradient(spread:pad, x1:0, y1:0, x2:1, y2:0, stop:0 rgba(251,102,102, 200), stop:1 rgba(20,196,188, 210));");
    ui->M1_Button->setStyleSheet("background-color:transparent");
    ui->M1_Button->setCursor(QCursor(Qt::PointingHandCursor));
    ui->pushButton_2->setStyleSheet("background-color:transparent");
    ui->pushButton_2->setCursor(QCursor(Qt::PointingHandCursor));
    ui->M1_Button_2->setStyleSheet("background-color:transparent");
    ui->M1_Button_2->setCursor(QCursor(Qt::PointingHandCursor));
    ui->check_box->view()->parentWidget()->setWindowFlags(Qt::Popup | Qt::FramelessWindowHint);
    ui->check_box->view()->parentWidget()->setAttribute(Qt::WA_TranslucentBackground);
}

HS_108fj::~HS_108fj()
{
    delete ui;
}

void HS_108fj::on_M1_Button_clicked()
{
    dc_exit(icdev);
    icdev = dc_init(100, 115200);
    unsigned char Snr[16]="\0";
    QString strcard;
    QString temp;
    int st = 0;
    char rbuff[1024] = "\0";
    int sector, password, block;

    sector = ui->sector->currentIndex();
    password = ui->check_box->currentIndex();
    block = ui->block->currentIndex();

    if ((long long) icdev < 0) {
        ui->Recv_Data->append(u8"请打开设备！");
        return;
    }
    st = dc_reset(icdev, 10);
    if(st < 0) {
        ui->Recv_Data->append(QString::number(st));
    }
    st = dc_config_card(icdev, 'A');
//    st=hs_card_double_hex(icdev,0x01,Snr);
    st=dc_card_double_hex(icdev,0x01,Snr);
    if (st == 0) {
        strcard = "Card sn is " + st;
        ui->Recv_Data->append(strcard);
    } else {
        ui->Recv_Data->append("Please put the card on the right position.");
        return ;
    }
    if (password == 1) {
        password  = 4;
    }
//    st = hs_authentication(icdev, password, sector);
    st = dc_authentication(icdev, password, sector);
    if(st != 0)
    {
        ui->Recv_Data->append(u8"密码错误");
        return ;
    }

    block = sector * 4 + block;
//    st = hs_read_hex(icdev,block,rbuff);
    st = dc_read_hex(icdev,block,rbuff);
    if(st != 0)
    {
        ui->Recv_Data->append("read info error");
        return ;
    }
    temp = rbuff;
    ui->Recv_Data->append(temp);
//    hs_beep(icdev, 10);
    dc_beep(icdev, 10);
}


void HS_108fj::on_pushButton_clicked()
{
    QString temp;
    int ret = 0;
    dc_exit(icdev);
    icdev = dc_init(100, 115200);

    if ((long long) icdev == -1) {
        ui->Recv_Data->append(u8"请打开设备！");
        return;
    }
    char strOutput[64] = "\0";
//    ret = hs_GetBankAccountNumber(icdev, 0, strOutput); //读取非接触式的银行卡
    ret = dc_GetBankAccountNumber(icdev, 0, strOutput);
    qDebug() << ret << endl;
    if (ret != 0) {
        ui->Recv_Data->append("get bank card false!!!");
        return;
    }
    else {
        ui->Recv_Data->append("bank card is:");
        temp = strOutput;
        ui->Recv_Data->append(temp);
//        hs_beep(icdev, 10);
        dc_beep(icdev, 10);
    }

}


void HS_108fj::on_clear_clicked()
{
    ui->Recv_Data->clear();
    ui->resetedit->clear();
    ui->sendCommnd->clear();
    ui->recvmessage->clear();
}


void HS_108fj::on_pushButton_2_clicked()
{
    password *son = new password;
    son->show();
}


void HS_108fj::on_M1_Button_2_clicked()
{
    unsigned char Snr[16]="\0";
    QString strcard;
    QString temp;
    int st = 0;
    char rbuff[1024] = "\0";
    int sector, password, block;
    dc_exit(icdev);
    icdev = dc_init(100, 115200);

    sector = ui->sector->currentIndex();
    password = ui->check_box->currentIndex();
    block = ui->block->currentIndex();

    if ((long long) icdev == -1) {
        ui->Recv_Data->append(u8"请打开设备！");
        return;
    }

//    st=hs_card_double_hex(icdev,0x01,Snr);
    st=dc_card_double_hex(icdev,0x01,Snr);
    if (st == 0) {
        strcard = "Card sn is " + st;
        ui->Recv_Data->append(strcard);
    } else {
        ui->Recv_Data->append("Please put the card on the right position.");
        return ;
    }
    if (password == 1) {
        password  = 4;
    }
//    st = hs_authentication(icdev, password, sector);
    st = dc_authentication(icdev, password, sector);
    if(st != 0)
    {
        ui->Recv_Data->append(u8"密码错误");
        return ;
    }

    block = sector * 4 + block;
//    st = hs_read_hex(icdev, block, rbuff);
    st = dc_read_hex(icdev, block, rbuff);
    if(st != 0)
    {
        ui->Recv_Data->append("read info error");
        return ;
    }
    temp = rbuff;
    ui->Recv_Data->append(u8"原内容：");
    ui->Recv_Data->append(temp);
    memcpy(rbuff, "11223344556677889900aabbccddeeff",32);
//    st = hs_write_hex(icdev,block,rbuff);
    st = dc_write_hex(icdev,block,rbuff);
    if (st != 0) {
        ui->Recv_Data->append("write data error");
        return;
    }
//    st = hs_read_hex(icdev, block, rbuff);
    st = dc_read_hex(icdev, block, rbuff);
    if(st != 0)
    {
        ui->Recv_Data->append("read info error");
        return ;
    }
    temp = rbuff;
    ui->Recv_Data->append(u8"第二次写入");
    ui->Recv_Data->append(temp);
//    hs_beep(icdev, 10);
    dc_beep(icdev,10);
}


void HS_108fj::on_reset_clicked()
{
    int st = 0;
    QString temp;
    unsigned char rlen = 0;
    unsigned char snr[8] = "\0";
    char recv[128] = "\0";
    unsigned int snrLen;

//    st = hs_card_n(icdev, 0, &snrLen, snr);
    st = dc_card_n(icdev, 0, &snrLen, snr);
    if (st == 0) {
//        st = hs_pro_resethex(icdev, &rlen, recv);
        st = dc_pro_resethex(icdev, &rlen, recv);
        if (st < 0) {
            ui->resetedit->setText(u8"复位失败2");
            return;
        }
        temp = recv;
        ui->resetedit->setText(temp);
    } else {
//        st = hs_pro_resethex(icdev, &rlen, recv);
        st = dc_pro_resethex(icdev, &rlen, recv);
        if (st == 0) {
            temp = recv;
            ui->resetedit->setText(temp);
        }
        ui->resetedit->setText(u8"寻卡失败");
    }
    //ui->resetedit->setText(u8"复位成功");
}


void HS_108fj::on_send_clicked()
{
    short  st = -1;
    int i = 0;
    unsigned char slen = 0,rlen = 0;
    char recv_data[512] = "\0";
    QString temp = ui->sendCommnd->text();
    QByteArray text = temp.toLatin1();
    i = text.length();
    char *sendbuf = text.data();
    slen = (char) (i / 2);
//    st = hs_pro_commandhex(icdev, slen, sendbuf, &rlen, recv_data, 7);
    st = dc_pro_commandhex(icdev, slen, sendbuf, &rlen, recv_data, 7);
    if (st < 0) {
        ui->recvmessage->setText(u8"接受数据错误");
        return ;
    }
    temp = recv_data;
    ui->recvmessage->setText(temp);
    return;
}

