﻿#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "hs_108fj.h"
#include "hs_108j.h"
#include "sam.h"
#include "usb.h"
//#include "HS_Reader.h"
#include <QMessageBox>

MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent)
    , ui(new Ui::QMainWindow)
{
    ui->setupUi(this);
    this->setWindowTitle("HS108");//设置窗口名
    this->setWindowIcon(QIcon(":/new/prefix1/logo.jpg"));
   // this->setStyleSheet("background-color: qlineargradient(spread:pad, x1:0, y1:0, x2:1, y2:0, stop:0 rgba(251,102,102, 200), stop:1 rgba(20,196,188, 210));");
    ui->NtouchCard->setStyleSheet("background-color:transparent");
    ui->NtouchCard->setCursor(QCursor(Qt::PointingHandCursor));
    ui->touchCard->setStyleSheet("background-color:transparent");
    ui->touchCard->setCursor(QCursor(Qt::PointingHandCursor));
    ui->SAM->setStyleSheet("background-color:transparent");
    ui->SAM->setCursor(QCursor(Qt::PointingHandCursor));
    ui->NtouchCard->setStyleSheet("QPushButton{border:2px groove gray;border-radius:20px;padding:2px 4px;border-style: outset;color: rgb(255, 255, 255);background-color: rgb(42, 170, 255);}");
    ui->touchCard->setStyleSheet("QPushButton{border:2px groove gray;border-radius:20px;padding:2px 4px;border-style: outset;color: rgb(255, 255, 255);background-color: rgb(42, 170, 255);}");
    ui->SAM->setStyleSheet("QPushButton{border:2px groove gray;border-radius:20px;padding:2px 4px;border-style: outset;color: rgb(255, 255, 255);background-color: rgb(42, 170, 255);}");
#if 0
    QPalette pal = this->palette();
    pal.setBrush(QPalette::Background, QBrush(QPixmap(":/new/prefix1/logo.jpg")));
    setPalette(pal);
#endif
}

MainWindow::~MainWindow()
{
    delete ui;
}


void MainWindow::on_NtouchCard_clicked()
{
    //this->close();
    if ((long long) icdev == -1) {
        QMessageBox::information(this, u8"提示信息", u8"请先打开设备");
        return;
    } else {
        HS_108fj *son = new HS_108fj;
        son->show();
    }
}


void MainWindow::on_touchCard_clicked()
{
    if ((long long) icdev == -1) {
        QMessageBox::information(this, u8"提示信息", u8"请先打开设备");
        return;
    } else {
        hs_108j *son = new hs_108j;
        son->show();
    }
}

#if 0
void MainWindow::on_pushButton_clicked()
{
    int driver;
    QMessageBox message;
    icdev = hs_init(100, 115200);//USB设备
    if((long long) icdev < 0) {
        message.information(this, u8"提示信息", "init error!!!");
        return;
    }
    hs_beep(icdev, 20);
}
#endif


void MainWindow::on_pushButton_2_clicked()
{
//    hs_beep(icdev, 10);
    dc_beep(icdev, 10);
//    hs_exit(icdev);
    dc_exit(icdev);
    icdev = (HANDLE) -1;
}


void MainWindow::on_pushButton_3_clicked()
{
    USB *son = new USB;
    son->show();
}


void MainWindow::on_SAM_clicked()
{
    if ((long long) icdev == -1) {
        QMessageBox::information(this, u8"提示信息", u8"请先打开设备");
        return;
    } else {
        SAM *son = new SAM;
        son->show();
    }
}

